/*
 * Go2ProfileCenterZ.c
 * 
 * Gocator system communication library
 * Copyright (C) 2013 by LMI Technologies Inc.
 * 
 * Licensed under The MIT License.
 * Redistributions of files must retain the above copyright notice.
 */

#include <z/Go2Measurements/zGo2ProfileCenterZ.h>
#include <z/zGo2ProfileTypes.h>
#include <z/zGo2System.h>
#include <string.h>

/*
 * Go2ProfileCenterZ Class 
 */

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_Construct(Go2ProfileCenterZ* measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileCenterZ output = zNIL; 
    Go2Status status = GO2_OK; 

    zCHECK(zCalloc(&output, 1, sizeof(Go2ProfileCenterZClass))); 

    if (!zSUCCESS(status = Go2ProfileCenterZ_Init(output, id, system)))
    {
        zCHECK(Go2Object_Destroy(output)); 
        return status; 
    }
    
    *measurement = output; 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_Init(Go2ProfileCenterZ measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileCenterZClass* obj = zHANDLE_POINTER(measurement);
    z32u i; 

    zCHECK(Go2Measurement_Init(measurement, GO2_TYPE_PROFILE_CENTER_Z, id, system)); 

    obj->Release = Go2ProfileCenterZ_VRelease; 
    obj->Read = Go2ProfileCenterZ_VRead; 
    obj->Write = Go2ProfileCenterZ_VWrite; 

    for (i = 0; i < zCOUNT(obj->features); ++i)
    {
        zCHECK(Go2ProfileFeature_Construct(&obj->features[i], system));       
    }

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_VRelease(Go2ProfileCenterZ measurement)
{
    Go2ProfileCenterZClass* obj = zHANDLE_POINTER(measurement);
    z32u i; 

    for (i = 0; i < zCOUNT(obj->features); ++i)
    {
        zCHECK(Go2Object_Destroy(obj->features[i])); 
    }

    zCHECK(Go2Measurement_VRelease(measurement));  
        
    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_VRead(Go2ProfileCenterZ measurement, zXml xml, zXmlItem item)
{
    Go2ProfileCenterZClass* obj = zHANDLE_POINTER(measurement); 
    zChar* text = zNULL;
    z32u textCapacity = GO2_MEASUREMENT_SOURCE_TEXT_CAPACITY; 

    zXmlItem featureItem = zNIL; 
    z32u i; 

    zCHECK(Go2Measurement_VRead(measurement, xml, item)); 

    zCHECK(zCalloc(&text, textCapacity, sizeof(zChar)));
    zCHECK(zXml_ChildText(xml, item, "SourceOptions", text, textCapacity)); 
    zCHECK(Go2OptionList_ParseList(text, obj->sourceOptions));  

    zCHECK(zXml_Child32u(xml, item, "Source", &obj->source)); 
    

    featureItem = zXml_Child(xml, item, "Feature"); 

    for (i = 0; i < zCOUNT(obj->features); ++i)
    {
        zCHECK(!zIS_NIL(featureItem)); 
        zCHECK(Go2ProfileFeature_Read(obj->features[i], xml, featureItem)); 

        featureItem = zXml_NextSibling(xml, featureItem); 
    }

    zCHECK(zFree(text));

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_VWrite(Go2ProfileCenterZ measurement, zXml xml, zXmlItem item)
{
    Go2ProfileCenterZClass* obj = zHANDLE_POINTER(measurement); 
    zXmlItem featureItem = zNIL; 
    z32u i; 

    zCHECK(Go2Measurement_VWrite(measurement, xml, item)); 

    zCHECK(zXml_SetChild32u(xml, item, "Source", obj->source)); 

    for (i = 0; i < zCOUNT(obj->features); ++i)
    {
        zCHECK(zXml_AddItem(xml, item, "Feature", &featureItem)); 
        zCHECK(Go2ProfileFeature_Write(obj->features[i], xml, featureItem)); 
    }

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_SetId(Go2ProfileCenterZ measurement, Go2UInt32 id)
{
    return Go2Measurement_SetId(measurement, id);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileCenterZ_Id(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_Id(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_SetName(Go2ProfileCenterZ measurement, const Go2Char* name)
{
    return Go2Measurement_SetName(measurement, name);     
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_Name(Go2ProfileCenterZ measurement, Go2Char* name, Go2UInt32 capacity)
{
    return Go2Measurement_Name(measurement, name, capacity);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileCenterZ_SourceOptionCount(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_SourceOptionCount(measurement);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileCenterZ_SourceOptionAt(Go2ProfileCenterZ measurement, Go2UInt32 index)
{
    return Go2Measurement_SourceOptionAt(measurement, index);     
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_SetSource(Go2ProfileCenterZ measurement, Go2ProfileSource source)
{
    return Go2Measurement_SetSource(measurement, source);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileCenterZ_Source(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_Source(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_SetDecisionMin(Go2ProfileCenterZ measurement, Go2Double min)
{
    return Go2Measurement_SetDecisionMin(measurement, min);     
}

GO2_EXPORT(Go2Double) Go2ProfileCenterZ_DecisionMin(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_DecisionMin(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_SetDecisionMax(Go2ProfileCenterZ measurement, Go2Double max)
{
    return Go2Measurement_SetDecisionMax(measurement, max);     
}

GO2_EXPORT(Go2Double) Go2ProfileCenterZ_DecisionMax(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_DecisionMax(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_EnableHold(Go2ProfileCenterZ measurement, Go2Bool enable)
{
    return Go2Measurement_EnableHold(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileCenterZ_HoldEnabled(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_HoldEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_EnableSmoothing(Go2ProfileCenterZ measurement, Go2Bool enable)
{
    return Go2Measurement_EnableSmoothing(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileCenterZ_SmoothingEnabled(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_SmoothingEnabled(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileCenterZ_SmoothingWindowMin(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_SmoothingWindowMin(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileCenterZ_SmoothingWindowMax(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_SmoothingWindowMax(measurement);  
} 

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_SetSmoothingWindow(Go2ProfileCenterZ measurement, Go2UInt32 window)
{
    return Go2Measurement_SetSmoothingWindow(measurement, window);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileCenterZ_SmoothingWindow(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_SmoothingWindow(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileCenterZ_FeatureCount(Go2ProfileCenterZ measurement)
{
    Go2ProfileCenterZClass* obj = zHANDLE_POINTER(measurement); 
    return zCOUNT(obj->features); 
}

GO2_EXPORT(Go2ProfileFeature) Go2ProfileCenterZ_FeatureAt(Go2ProfileCenterZ measurement, Go2UInt32 index)
{
    Go2ProfileCenterZClass* obj = zHANDLE_POINTER(measurement); 
    return obj->features[index];  
}



GO2_EXPORT(Go2Status) Go2ProfileCenterZ_SetScale(Go2ProfileCenterZ measurement, Go2Double scale){
    return Go2Measurement_SetScale(measurement, scale);
}

GO2_EXPORT(Go2Double) Go2ProfileCenterZ_Scale(Go2ProfileCenterZ measurement){
    return Go2Measurement_Scale(measurement);
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_SetOffset(Go2ProfileCenterZ measurement, Go2Double offset){
    return Go2Measurement_SetOffset(measurement, offset);
}

GO2_EXPORT(Go2Double) Go2ProfileCenterZ_Offset(Go2ProfileCenterZ measurement){
    return Go2Measurement_Offset(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileCenterZ_LinkOptionCount(Go2ProfileCenterZ measurement)
{
    return Go2Measurement_LinkOptionCount(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileCenterZ_LinkOptionAt(Go2ProfileCenterZ measurement, Go2UInt32 index)
{
    return Go2Measurement_LinkOptionAt(measurement, index);
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_EnableLink(Go2ProfileCenterZ measurement, Go2Bool enable)  
{
    return Go2Measurement_EnableLink(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2ProfileCenterZ_LinkEnabled(Go2ProfileCenterZ measurement)  
{
    return Go2Measurement_LinkEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileCenterZ_SetLink(Go2ProfileCenterZ measurement, Go2UInt32 link) 
{
    return Go2Measurement_SetLink(measurement, link); 
}

GO2_EXPORT(Go2UInt32) Go2ProfileCenterZ_Link(Go2ProfileCenterZ measurement) 
{
    return Go2Measurement_Link(measurement); 
}
